Bug 4510 - Marshal.SizeOf returning different sizes for StructLayout(Explicit) vs. StructLayout(Sequential)
Summary: Marshal.SizeOf returning different sizes for StructLayout(Explicit) vs. Struc...
Status: RESOLVED FIXED
Alias: None
Product: Runtime
Classification: Mono
Component: General (show other bugs)
Version: unspecified
Hardware: PC Mac OS
: High normal
Target Milestone: ---
Assignee: Paolo Molaro
URL:
Depends on:
Blocks:
 
Reported: 2012-04-18 16:31 UTC by Eric Beisecker
Modified: 2014-07-30 08:44 UTC (History)
4 users (show)

Tags:
Is this bug a regression?: ---
Last known good build:

Notice (2018-05-24): bugzilla.xamarin.com is now in read-only mode.

Please join us on Visual Studio Developer Community and in the Xamarin and Mono organizations on GitHub to continue tracking issues. Bugzilla will remain available for reference in read-only mode. We will continue to work on open Bugzilla bugs, copy them to the new locations as needed for follow-up, and add the new items under Related Links.

Our sincere thanks to everyone who has contributed on this bug tracker over the years. Thanks also for your understanding as we make these adjustments and improvements for the future.


Please create a new report on GitHub or Developer Community with your current version information, steps to reproduce, and relevant error messages or log files if you are hitting an issue that looks similar to this resolved bug and you do not yet see a matching new report.

Related Links:
Status:
RESOLVED FIXED

Description Eric Beisecker 2012-04-18 16:31:23 UTC
Example:

[StructLayout(LayoutKind.Explicit)]
struct A
{
  [FieldOffset(0)]
  int one;
  [FieldOffset(4)]
  int two;
  [FieldOffset(8)]
  int three;
}

[StructLayout(LayoutKind.Sequential)]
struct B
{
  int one;
  int two;
  int three;
}

Console.WriteLine(Marshal.SizeOf(new A())); // Will return 16
Console.WriteLine(Marshal.SizeOf(new B())); // Will return 12

Using the .NET library both examples Return 12.
Comment 1 Rodrigo Kumpera 2014-01-22 16:52:09 UTC
Fixed in master.